/*!	
	@file
	@brief	`施߃bZ[W `
*/

#ifndef CRenderMessage_h
#define CRenderMessage_h

#include"../Setup/CompileMode.h"
#include"../Template/Mathematics.h"
#include"../Auxiliary/mstring.h"
#include<boost/smart_ptr.hpp>
#include<vector>


namespace Maid
{
	//	`Xbhɓ@bZ[WNX

	namespace RenderMessage
	{
		class Base
		{
		public:
			//	`惁bZ[W
			enum MESSAGE
			{
				NONE,				//!<	Ȃ

				SCREENCHANGE,		//!<	XN[[hύX

				REGISTSURFACE,		//!<	T[tFX̓o^
				REGISTTEXTURE,		//!<	eNX`̓o^
				REGISTRTTEXTURE,	//!<	_OeNX`̍쐬
				REGISTVERTEX,		//!<	_̓o^
				REGISTINDEX,		//!<	CfbNX̓o^
				REGISTVERTEXSHADER,	//!<	o[ebNXVF[_[̓o^
				REGISTVERTEXDECLARATION,	//!<	_`̓o^
				REGISTPIXELSHADER,	//!<	sNZVF[_[̓o^

				DELETESURFACE,		//!<	T[tFX̔j
				DELETETEXTURE,		//!<	eNX`̔j
				DELETEVERTEX,		//!<	_̔j
				DELETEINDEX,		//!<	CfbNX̔j
				DELETEVERTEXSHADER,	//!<	o[ebNXVF[_[̔j
				DELETEVERTEXDECLARATION,	//!<	_`̓o^
				DELETEPIXELSHADER,	//!<	sNZVF[_[̔j


				RENDERTARGET_CLEAR_COLOR,		//!<	`̃NA
				RENDERTARGET_CLEAR_Z,			//!<	`̃NA

				UNSETTEXTURE,		//!<	eNX`͂
				RESETRENDERTARGET,	//!<	_[^[Qbg̃Zbg
				SETRENDERTARGET,	//!<	_[^[Qbg̃Zbg
				SETTEXTURE,			//!<	eNX`̃Zbg
				SETVERTEX,			//!<	_̃Zbg
				SETINDEX,			//!<	CfbNX̃Zbg
				SETVERTEXSHADER,	//!<	o[ebNXVF[_[̃Zbg
				SETPIXELSHADER,		//!<	sNZVF[_[̃Zbg
				SETVERTEXDECLARATION,	//!<	_`̃Zbg

				SETVERTEXSHADER_CONSTF,	//!<	const float Zbg

				SETVIEWPORT,		//!<	r[|[g̐ݒ
				SETRENDERSTATE,		//!<	_[Xe[g
				SETSAMPLERSTATE,

				DRAWPRIMITIVE,		//!<	|S̕`
				DRAWPRIMITIVEUP,	//!<	|S̕`
				DRAWINDEXPRIMITIVE,	//!<	|S̕`
				DRAWINDEXPRIMITIVEUP,	//!<	|S̕`

				COPYSURFACE,		//!<	VXeɓ]
				GETVIDEOINFO,		//!<	rfI\͂擾
			};

			Base( MESSAGE mess ) : Message(mess){}

			const MESSAGE	Message;
			mstring GetMessage() const;
		};
	}

	typedef	boost::shared_ptr<RenderMessage::Base>	SPRENDERMESSAGE;
	typedef	MySTL::vector<SPRENDERMESSAGE>			RENDERMESSAGEQUE;

	typedef boost::shared_ptr<MySTL::vector<unt08> > SPBINARY;

}


#endif
